#include "tricks.h"
#include "time.h"

byte buffer[64000];

struct particle
{
    float x, y;
    float xd, yd;
    byte l;
};

void blur( int grade, int y_start, int y_end, int x_start, int x_end);
void init();
void red();

#define parts 2000
#define frames 500
#define fade 4

particle *p;
int frame;
byte divtab[256*9];
float slowtab[parts+frames];

void main()
{
    p = new particle[parts];

    GrabPallette();
    SetMCGA();

    red();
    init();
    srand(time(NULL));

    for( int i=0; i<256*9; i++)
    {
        if( (i/9)-fade < 0 )
            divtab[i] = 0;
        else
            divtab[i] = (i/9)-fade;        
    }

    while( !kbhit() )
    {       
        for( i=0; i<parts; i++ )
        {
            p[i].y -= p[i].yd;
            p[i].x -= p[i].xd;

            if( p[i].y > 197 )
            {
                p[i].y += p[i].yd*2;
                p[i].yd *= slowtab[i+frame];
            }

            if( p[i].x > 317 || p[i].x < 3 )
            {
                p[i].x += p[i].xd*2;
                p[i].xd *= (slowtab[i+frame]-0.5);
            }

            if( p[i].l && frame&1 )
                p[i].l--;

            p[i].yd -= 0.02;
            p[i].xd *= 0.995;

            if( p[i].l && p[i].y > 2)
                buffer[ (int)p[i].x + ((int)p[i].y)*320 ] = p[i].l;
        }

//        WaitRetrace();

        if( frame++ > frames ) init();

        blur( 4, 2, 198, 2, 318 );

          int *v= (int*) vga;
          int *b= (int*) buffer;
   
          for( i=0; i<4000; i++)
          {
             *v++ = *b++;
             *v++ = *b++;
             *v++ = *b++;
             *v++ = *b++;
          }
    }

    SetText();
    RestorePallette();

    delete[] p;
}

void init()
{
    float xr,yr,r;

    xr = float( rand() ) / 36000 * 310+5;
    yr = float( rand() ) / 36000 * 190+5;
    r = float( rand() ) /3 + 11000;

    for( int i=0; i<parts; i++ )
    {
        p[i].x = xr;
        p[i].y = yr;

        float speed = float( rand() ) / r;

        p[i].xd = cos( 2*PI*i/parts ) * speed * 1.5;
        p[i].yd = sin( 2*PI*i/parts ) * speed;                                        
        p[i].l = 255;
    }

    frame = 0;

    for( i=0; i<parts+frames; i++)
       slowtab[i] = (float(i%20)/-40)-0.3;
}

void blur( int grade, int y_start, int y_end, int x_start, int x_end)
{
    byte *temp;

    for(int y=y_start; y<y_end; y++)
	{
        temp = buffer + y*320 + x_start;

        for(int x=x_start; x<x_end; x++, temp++)
            *temp = divtab[temp[-321]+temp[-320]+temp[-319]+
                           temp[-1]  +temp[0]   +temp[1]+
                           temp[319] +temp[320] +temp[321]];
	}
}


void red()  
{
    for( int color = 1; color < 64; color++ )
        Pal( color, color,0,0 );

    for( color = 64; color < 128; color++ )
        Pal( color, 63,color-64,0);

    for( color = 128 ; color < 192; color++ )
        Pal( color, 63, 63,color-128);

    for( color = 192; color < 256; color++ )
		Pal( color, 63, 63, 63);
}
